#! /usr/bin/perl

# Copyright (c) 2010 Novell Inc.
# derived from code (C) 2001-2009 Aristotle Pagaltzis

use strict;

my ($conffile, @flg) = @ARGV;

my $KILL_PROC="killproc"; 
my $PUREFTPD;
-x && ($PUREFTPD=$_, last) for qw(
	${exec_prefix}/sbin/pure-ftpd
	/usr/local/pure-ftpd/sbin/pure-ftpd
	/usr/local/pureftpd/sbin/pure-ftpd
	/usr/local/sbin/pure-ftpd
	/usr/sbin/pure-ftpd
);

my %string_switch_for = (
	PIDFile                 => "-p",
	);				    

my $string_switch = qr/(@{[join "|", keys %string_switch_for ]})\s+(\S+)/i;

die "Usage: pure-ftpd-stop.pl <configuration file>\n"
	unless defined $conffile;

open CONF, "< $conffile" or die "Can't open $conffile: $!\n";

!/^\s*(?:$|#)/ and (chomp, push @flg,
	/$string_switch/i               ? ($string_switch_for{$1} . $2) :
	()
) while <CONF>;
 
push @flg, (-G);
push @flg, (-TERM);
push @flg, ($PUREFTPD);

close CONF;

print "Running: $KILL_PROC ", join(" ", @flg), "\n";
exec { $KILL_PROC } ($KILL_PROC, @flg) or die "cannot exec $KILL_PROC: $!";
